## chromaprint 0.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

project(chromaprint)
set(PROJECT_VERSION 0.3.0)

# 1. If the library source code has changed at all since the last update, then increment revision.
# 2. If any interfaces have been added, removed, or changed since the last update, increment current, and set revision to 0.
# 3. If any interfaces have been added since the last public release, then increment age.
# 4. If any interfaces have been removed since the last public release, then set age to 0. 
set(chromaprint_SOVERSION_CURRENT  1)
set(chromaprint_SOVERSION_REVISION 1)
set(chromaprint_SOVERSION_AGE      1)

math(EXPR chromaprint_SOVERSION_MAJOR "${chromaprint_SOVERSION_CURRENT} - ${chromaprint_SOVERSION_AGE}")
math(EXPR chromaprint_SOVERSION_MINOR "${chromaprint_SOVERSION_AGE}")
math(EXPR chromaprint_SOVERSION_PATCH "${chromaprint_SOVERSION_REVISION}")

set(chromaprint_VERSION ${chromaprint_SOVERSION_MAJOR}.${chromaprint_SOVERSION_MINOR}.${chromaprint_SOVERSION_PATCH})
set(chromaprint_SOVERSION ${chromaprint_SOVERSION_MAJOR})

include(CheckFunctionExists)
set(CMAKE_REQUIRED_LIBRARIES -lm)
check_function_exists(lrintf HAVE_LRINTF)
check_function_exists(round HAVE_ROUND)

add_definitions(
	-DHAVE_CONFIG_H
	-D_SCL_SECURE_NO_WARNINGS
	-D_USE_MATH_DEFINES
	-D__STDC_LIMIT_MACROS
	-D__STDC_CONSTANT_MACROS
)
include_directories(${CMAKE_CURRENT_SOURCE_DIR})
include_directories(${CMAKE_CURRENT_BINARY_DIR})

set(LIB_SUFFIX "" CACHE STRING "Define suffix of directory name (32/64)")
set(EXEC_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX} CACHE PATH "Installation prefix for executables and object code libraries" FORCE)
set(BIN_INSTALL_DIR ${EXEC_INSTALL_PREFIX}/bin CACHE PATH "Installation prefix for user executables" FORCE)
set(LIB_INSTALL_DIR ${EXEC_INSTALL_PREFIX}/lib${LIB_SUFFIX} CACHE PATH  "Installation prefix for object code libraries" FORCE)
set(INCLUDE_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/include CACHE PATH "Installation prefix for C header files" FORCE)

#if(CMAKE_COMPILER_IS_GNUCXX)
#	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility=hidden -fvisibility-inlines-hidden")
#	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fvisibility=hidden -fvisibility-inlines-hidden")
#endif(CMAKE_COMPILER_IS_GNUCXX)

option(BUILD_TESTS "Build the test suite" OFF)
option(BUILD_TOOLS "Build standard tools" OFF)
option(BUILD_EXTRA_TOOLS "Build extra tools (only useful for development of this library)" OFF)

option(WITH_AVFFT "Use FFmpeg for FFT calculations" OFF)
option(WITH_FFTW3 "Use FFTW3 for FFT calculations" OFF)
option(WITH_VDSP "Use vDSP for FFT calculations" OFF)

set(TESTS_DIR ${CMAKE_CURRENT_SOURCE_DIR}/tests/)

set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules)
find_package(FFmpeg)
find_package(FFTW3)
if(APPLE)
	find_library(ACCELERATE_LIBRARIES Accelerate)
endif()

set(FFT_OPTION_COUNT 0)

if(WITH_AVFFT)
	math(EXPR FFT_OPTION_COUNT "${FFT_OPTION_COUNT} + 1")
endif()
if(WITH_FFTW3)
	math(EXPR FFT_OPTION_COUNT "${FFT_OPTION_COUNT} + 1")
endif()
if(WITH_VDSP)
	math(EXPR FFT_OPTION_COUNT "${FFT_OPTION_COUNT} + 1")
endif()
if(FFT_OPTION_COUNT GREATER "1")
	message(FATAL_ERROR "Only one of WITH_AVFFT, WITH_FFTW3 AND WITH_VDSP can be selected")
endif()

if(WITH_AVFFT AND NOT FFMPEG_LIBAVCODEC_FFT_FOUND)
	message(FATAL_ERROR "FFmpeg with avfft.h not found")
endif()

if(WITH_FFTW3 AND NOT FFTW3_FOUND)
	message(FATAL_ERROR "FFTW3 not found")
endif()

if(APPLE AND WITH_VDSP AND NOT ACCELERATE_LIBRARIES)
	message(FATAL_ERROR "vDSP (Accelerate) not found")
endif()

if(NOT WITH_AVFFT AND NOT WITH_FFTW3)
	if(APPLE AND ACCELERATE_LIBRARIES)
		set(WITH_VDSP ON)
	elseif(FFMPEG_LIBAVCODEC_FFT_FOUND)
		set(WITH_AVFFT ON)
	elseif(FFTW3_FOUND)
		set(WITH_FFTW3 ON)
	else()
		message(FATAL_ERROR "Neither FFmpeg with avfft.h nor FFTW3 found")
	endif()
endif()

if(WITH_AVFFT)
	message(STATUS "Using FFmpeg for FFT calculations")
endif(WITH_AVFFT)

if(WITH_FFTW3)
	message(STATUS "Using FFTW3 for FFT calculations")
endif(WITH_FFTW3)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/libchromaprint.pc.cmake ${CMAKE_CURRENT_BINARY_DIR}/libchromaprint.pc)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libchromaprint.pc DESTINATION ${LIB_INSTALL_DIR}/pkgconfig)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/config.h.in ${CMAKE_CURRENT_BINARY_DIR}/config.h)

add_subdirectory(src)

if(BUILD_TOOLS_EXTRA)
	find_package(PNG REQUIRED)
endif(BUILD_TOOLS_EXTRA)

find_package(Boost COMPONENTS system filesystem)
if(BUILD_TOOLS OR BUILD_TOOLS_EXTRA)
	find_package(FFmpeg REQUIRED)
	find_package(Taglib REQUIRED)
	add_subdirectory(tools)
endif(BUILD_TOOLS OR BUILD_TOOLS_EXTRA)

if(BUILD_TESTS)
	find_package(GTest REQUIRED)
	add_subdirectory(tests)
endif(BUILD_TESTS)

=== src/CMakeLists.txt ===
include_directories(${CMAKE_CURRENT_SOURCE_DIR})

set(chromaprint_SRCS
	chromaprint.cpp
	audio_processor.cpp
	chroma.cpp
	chroma_resampler.cpp
	chroma_filter.cpp
	integral_image.cpp
	spectrum.cpp
	spectral_centroid.cpp
	filter.cpp
	fft.cpp
	fingerprinter.cpp
	image_builder.cpp
	lloyds.cpp
	silence_remover.cpp
	fingerprint_calculator.cpp
	fingerprint_compressor.cpp
	fingerprint_decompressor.cpp
	fingerprinter_configuration.cpp
	base64.cpp
	avresample/resample2.c
)

if(WITH_AVFFT)
	set(chromaprint_SRCS fft_lib_avfft.cpp ${chromaprint_SRCS})
	set(chromaprint_LINK_LIBS
		${FFMPEG_LIBAVCODEC_LIBRARIES}
		${FFMPEG_LIBAVUTIL_LIBRARIES}
	)
	include_directories(
		${FFMPEG_LIBAVCODEC_INCLUDE_DIRS}
		${FFMPEG_LIBAVFORMAT_INCLUDE_DIRS}
		${FFMPEG_LIBAVUTIL_INCLUDE_DIRS}
	)
endif(WITH_AVFFT)

if(WITH_FFTW3)
	set(chromaprint_SRCS fft_lib_fftw3.cpp ${chromaprint_SRCS})
	set(chromaprint_LINK_LIBS ${FFTW3_LIBRARIES})
	include_directories(${FFTW3_INCLUDE_DIR})
endif(WITH_FFTW3)

if(WITH_VDSP)
	set(chromaprint_SRCS fft_lib_vdsp.cpp ${chromaprint_SRCS})
	set(chromaprint_LINK_LIBS ${ACCELERATE_LIBRARIES})
endif()

add_library(chromaprint_p STATIC ${chromaprint_SRCS})
target_link_libraries(chromaprint_p ${chromaprint_LINK_LIBS})

add_library(chromaprint SHARED ${chromaprint_SRCS} ${chromaprint_SRCS})
set_target_properties(chromaprint PROPERTIES
    VERSION ${chromaprint_VERSION}
    SOVERSION ${chromaprint_SOVERSION}
    DEFINE_SYMBOL CHROMAPRINT_API_EXPORTS
)
target_link_libraries(chromaprint ${chromaprint_LINK_LIBS})

install(FILES chromaprint.h DESTINATION ${INCLUDE_INSTALL_DIR})
install(TARGETS chromaprint DESTINATION ${LIB_INSTALL_DIR})

=== tests/CMakeLists.txt ===
include_directories(
	${GTEST_INCLUDE_DIRS}
	${CMAKE_CURRENT_SOURCE_DIR}/../src
)

set(tests_SOURCES
	main.cpp
	test_api.cpp
	test_combined_buffer.cpp
	test_utils.cpp
	test_quantizer.cpp
	test_filter_utils.cpp
	test_integral_image.cpp
	test_lloyds.cpp
	test_audio_processor.cpp
	test_bit_string_reader.cpp
	test_bit_string_writer.cpp
	test_chromaprint.cpp
	test_chroma.cpp
	test_chroma_filter.cpp
	test_chroma_resampler.cpp
	test_fingerprint_compressor.cpp
	test_fingerprint_decompressor.cpp
	test_fingerprint_calculator.cpp
	test_filter.cpp
	test_silence_remover.cpp
	test_base64.cpp
)

add_executable(all_tests ${tests_SOURCES})
target_link_libraries(all_tests
	${GTEST_BOTH_LIBRARIES}
	chromaprint_p
)

add_custom_target(check
	./all_tests $ENV{GTEST_FLAGS}
	DEPENDS all_tests
)

=== tools/CMakeLists.txt ===
include_directories(
	${CMAKE_CURRENT_SOURCE_DIR}/../src
	${FFMPEG_LIBAVCODEC_INCLUDE_DIRS}
	${FFMPEG_LIBAVFORMAT_INCLUDE_DIRS}
	${FFMPEG_LIBAVUTIL_INCLUDE_DIRS}
	${Boost_INCLUDE_DIRS}
	${TAGLIB_INCLUDES}
)

if(BUILD_EXTRA_TOOLS)

	add_executable(resample resample.cpp)
	target_link_libraries(resample chromaprint_p
		${FFMPEG_LIBAVFORMAT_LIBRARIES}
		${FFMPEG_LIBAVCODEC_LIBRARIES}
		${FFMPEG_LIBAVUTIL_LIBRARIES})

	add_executable(decode decode.cpp)
	target_link_libraries(decode chromaprint_p
		${FFMPEG_LIBAVFORMAT_LIBRARIES}
		${FFMPEG_LIBAVCODEC_LIBRARIES}
		${FFMPEG_LIBAVUTIL_LIBRARIES})

	add_executable(chromagram chromagram.cpp)
	target_link_libraries(chromagram chromaprint_p
		${FFMPEG_LIBAVFORMAT_LIBRARIES}
		${FFMPEG_LIBAVCODEC_LIBRARIES}
		${FFMPEG_LIBAVUTIL_LIBRARIES}
		-lpng)

	add_executable(spectrogram spectrogram.cpp)
	target_link_libraries(spectrogram chromaprint_p
		${FFMPEG_LIBAVFORMAT_LIBRARIES}
		${FFMPEG_LIBAVCODEC_LIBRARIES}
		${FFMPEG_LIBAVUTIL_LIBRARIES}
		-lpng)

	add_executable(learn_filters learn_filters.cpp)
	target_link_libraries(learn_filters chromaprint_p
		${FFMPEG_LIBAVFORMAT_LIBRARIES}
		${FFMPEG_LIBAVCODEC_LIBRARIES}
		${FFMPEG_LIBAVUTIL_LIBRARIES}
		${Boost_SYSTEM_LIBRARY}
		${Boost_FILESYSTEM_LIBRARY})

	add_executable(fpeval fpeval.cpp)
	target_link_libraries(fpeval chromaprint_p
		${FFMPEG_LIBAVFORMAT_LIBRARIES}
		${FFMPEG_LIBAVCODEC_LIBRARIES}
		${FFMPEG_LIBAVUTIL_LIBRARIES}
		${Boost_SYSTEM_LIBRARY}
		${Boost_FILESYSTEM_LIBRARY})

endif(BUILD_EXTRA_TOOLS)

add_executable(fpgen fpgen.cpp)
target_link_libraries(fpgen chromaprint_p
	${FFMPEG_LIBAVFORMAT_LIBRARIES}
	${FFMPEG_LIBAVCODEC_LIBRARIES}
	${FFMPEG_LIBAVUTIL_LIBRARIES})

if(NOT MSVC)
add_executable(fpcollect fpcollect.cpp)
target_link_libraries(fpcollect chromaprint_p
	${FFMPEG_LIBAVFORMAT_LIBRARIES}
	${FFMPEG_LIBAVCODEC_LIBRARIES}
	${FFMPEG_LIBAVUTIL_LIBRARIES}
	${TAGLIB_LIBRARIES})
endif()

=== debian/changelog ===
chromaprint (0.3-1) unstable; urgency=low

  * Initial upload to Debian, based on upstream packaging.

 -- Clint Adams <clint@debian.org>  Mon, 02 May 2011 16:38:01 -0400

=== debian/control ===
Source: chromaprint
Priority: extra
Maintainer: Clint Adams <clint@debian.org>
Build-Depends: debhelper (>= 7.0.50~), cmake, libavcodec-dev, libavformat-dev, libfftw3-dev, libgtest-dev, python-all-dev (>= 2.3.5-11)
Standards-Version: 3.9.2
Section: libs
Homepage: http://wiki.acoustid.org/wiki/Chromaprint
Vcs-Git: git://git.debian.org/git/users/clint/chromaprint.git
Vcs-Browser: http://git.debian.org/?p=users/clint/chromaprint.git;a=summary

Package: libchromaprint-dev
Section: libdevel
Architecture: any
Depends: libchromaprint0 (= ${binary:Version}), ${misc:Depends}
Description: audio fingerprinting library
 Chromaprint is a library for calculating audio fingerprints
 which are used by the Acoustid service.

Package: libchromaprint0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: audio fingerprint library - development files
 Chromaprint is a library for calculating audio fingerprints,
 which are used by the Acoustid service.
 .
 This package includes development files needed to compile programs
 using libchromaprint.

Package: python-chromaprint
Section: python
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends}, libchromaprint0 (>= ${binary:Version})
Description: audio fingerprint library - Python bindings
 Chromaprint is a library for calculating audio fingerprints,
 which are used by the Acoustid service.
 .
 This package includes a Python package that wraps the Chromaprint library.

=== debian/watch ===
version=3
https://github.com/lalinsky/chromaprint/downloads .*/chromaprint-(.*)\.tar\.gz

## chromaprint 0.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,14 +1,14 @@
 cmake_minimum_required(VERSION 2.6)
 
 project(chromaprint)
-set(PROJECT_VERSION 0.3.0)
+set(PROJECT_VERSION 0.4.0)
 
 # 1. If the library source code has changed at all since the last update, then increment revision.
 # 2. If any interfaces have been added, removed, or changed since the last update, increment current, and set revision to 0.
 # 3. If any interfaces have been added since the last public release, then increment age.
 # 4. If any interfaces have been removed since the last public release, then set age to 0. 
 set(chromaprint_SOVERSION_CURRENT  1)
-set(chromaprint_SOVERSION_REVISION 1)
+set(chromaprint_SOVERSION_REVISION 2)
 set(chromaprint_SOVERSION_AGE      1)
 
 math(EXPR chromaprint_SOVERSION_MAJOR "${chromaprint_SOVERSION_CURRENT} - ${chromaprint_SOVERSION_AGE}")
@@ -39,14 +39,29 @@
 set(LIB_INSTALL_DIR ${EXEC_INSTALL_PREFIX}/lib${LIB_SUFFIX} CACHE PATH  "Installation prefix for object code libraries" FORCE)
 set(INCLUDE_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/include CACHE PATH "Installation prefix for C header files" FORCE)
 
-#if(CMAKE_COMPILER_IS_GNUCXX)
-#	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility=hidden -fvisibility-inlines-hidden")
-#	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fvisibility=hidden -fvisibility-inlines-hidden")
-#endif(CMAKE_COMPILER_IS_GNUCXX)
+if(APPLE)
+	option(BUILD_FRAMEWORK "Build an OS X framework" OFF)
+	set(FRAMEWORK_INSTALL_DIR "/Library/Frameworks" CACHE STRING "Directory to install frameworks to.")
+endif()
 
+option(BUILD_SHARED_LIBS "Build shared libraries" ON)
+option(BUILD_EXAMPLES "Build the examples" OFF)
 option(BUILD_TESTS "Build the test suite" OFF)
 option(BUILD_TOOLS "Build standard tools" OFF)
 option(BUILD_EXTRA_TOOLS "Build extra tools (only useful for development of this library)" OFF)
+
+if(CMAKE_COMPILER_IS_GNUCXX)
+	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall")
+	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall")
+endif()
+if(CMAKE_COMPILER_IS_GNUCXX AND BUILD_SHARED_LIBS)
+	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility=hidden -fvisibility-inlines-hidden")
+	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fvisibility=hidden")
+endif()
+
+if(NOT BUILD_SHARED_LIBS)
+	add_definitions(-DCHROMAPRINT_NODLL)
+endif()
 
 option(WITH_AVFFT "Use FFmpeg for FFT calculations" OFF)
 option(WITH_FFTW3 "Use FFTW3 for FFT calculations" OFF)
@@ -108,8 +123,10 @@
 	message(STATUS "Using FFTW3 for FFT calculations")
 endif(WITH_FFTW3)
 
-configure_file(${CMAKE_CURRENT_SOURCE_DIR}/libchromaprint.pc.cmake ${CMAKE_CURRENT_BINARY_DIR}/libchromaprint.pc)
-install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libchromaprint.pc DESTINATION ${LIB_INSTALL_DIR}/pkgconfig)
+if(NOT APPLE AND NOT BUILD_FRAMEWORK)
+	configure_file(${CMAKE_CURRENT_SOURCE_DIR}/libchromaprint.pc.cmake ${CMAKE_CURRENT_BINARY_DIR}/libchromaprint.pc)
+	install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libchromaprint.pc DESTINATION ${LIB_INSTALL_DIR}/pkgconfig)
+endif()
 
 configure_file(${CMAKE_CURRENT_SOURCE_DIR}/config.h.in ${CMAKE_CURRENT_BINARY_DIR}/config.h)
 
@@ -120,8 +137,15 @@
 endif(BUILD_TOOLS_EXTRA)
 
 find_package(Boost COMPONENTS system filesystem)
+if(BUILD_TOOLS OR BUILD_TOOLS_EXTRA OR BUILD_EXAMPLES)
+	find_package(FFmpeg REQUIRED)
+endif()
+
+if(BUILD_EXAMPLES)
+	add_subdirectory(examples)
+endif()
+
 if(BUILD_TOOLS OR BUILD_TOOLS_EXTRA)
-	find_package(FFmpeg REQUIRED)
 	find_package(Taglib REQUIRED)
 	add_subdirectory(tools)
 endif(BUILD_TOOLS OR BUILD_TOOLS_EXTRA)

=== examples/CMakeLists.txt ===
include_directories(
	${CMAKE_CURRENT_SOURCE_DIR}/../src
	${FFMPEG_LIBAVCODEC_INCLUDE_DIRS}
	${FFMPEG_LIBAVFORMAT_INCLUDE_DIRS}
	${FFMPEG_LIBAVUTIL_INCLUDE_DIRS}
)

add_executable(fpcalc fpcalc.c)

set(EXTRA_LIBS)
if(APPLE)
    set(EXTRA_LIBS ${EXTRA_LIBS} -lz)
endif()
if(UNIX)
    set(EXTRA_LIBS ${EXTRA_LIBS} -lpthread)
endif()

target_link_libraries(fpcalc chromaprint
	${FFMPEG_LIBAVFORMAT_LIBRARIES}
	${FFMPEG_LIBAVCODEC_LIBRARIES}
	${FFMPEG_LIBAVUTIL_LIBRARIES}
	${EXTRA_LIBS})

install(TARGETS fpcalc
	RUNTIME DESTINATION ${BIN_INSTALL_DIR}
)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -50,14 +50,25 @@
 add_library(chromaprint_p STATIC ${chromaprint_SRCS})
 target_link_libraries(chromaprint_p ${chromaprint_LINK_LIBS})
 
-add_library(chromaprint SHARED ${chromaprint_SRCS} ${chromaprint_SRCS})
+set(chromaprint_HDRS chromaprint.h)
+
+add_library(chromaprint ${chromaprint_SRCS} ${chromaprint_SRCS} ${chromaprint_HDRS})
 set_target_properties(chromaprint PROPERTIES
     VERSION ${chromaprint_VERSION}
     SOVERSION ${chromaprint_SOVERSION}
+	PUBLIC_HEADER ${chromaprint_HDRS}
     DEFINE_SYMBOL CHROMAPRINT_API_EXPORTS
 )
+if(BUILD_FRAMEWORK)
+	set_target_properties(chromaprint PROPERTIES FRAMEWORK TRUE)
+endif()
 target_link_libraries(chromaprint ${chromaprint_LINK_LIBS})
 
-install(FILES chromaprint.h DESTINATION ${INCLUDE_INSTALL_DIR})
-install(TARGETS chromaprint DESTINATION ${LIB_INSTALL_DIR})
+install(TARGETS chromaprint
+	FRAMEWORK DESTINATION ${FRAMEWORK_INSTALL_DIR}
+	LIBRARY DESTINATION ${LIB_INSTALL_DIR}
+	RUNTIME DESTINATION ${BIN_INSTALL_DIR}
+	ARCHIVE DESTINATION ${LIB_INSTALL_DIR}
+	PUBLIC_HEADER DESTINATION ${INCLUDE_INSTALL_DIR}
+)

=== debian/changelog ===
chromaprint (0.4-1.1) unstable; urgency=low

  * Non-maintainer upload.
  * add build-depends on python-support (Closes: #642448)

 -- Mike O'Connor <stew@debian.org>  Tue, 01 Nov 2011 21:28:01 -0400

chromaprint (0.4-1) unstable; urgency=low

  * New upstream release.

 -- Clint Adams <clint@debian.org>  Wed, 15 Jun 2011 20:03:33 -0400

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: chromaprint
 Priority: extra
 Maintainer: Clint Adams <clint@debian.org>
-Build-Depends: debhelper (>= 7.0.50~), cmake, libavcodec-dev, libavformat-dev, libfftw3-dev, libgtest-dev, python-all-dev (>= 2.3.5-11)
+Build-Depends: debhelper (>= 7.0.50~), cmake, libavcodec-dev, libavformat-dev, libfftw3-dev, libgtest-dev, python-support, python-all-dev (>= 2.3.5-11)
 Standards-Version: 3.9.2
 Section: libs
 Homepage: http://wiki.acoustid.org/wiki/Chromaprint

## chromaprint 0.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,14 +1,14 @@
 cmake_minimum_required(VERSION 2.6)
 
 project(chromaprint)
-set(PROJECT_VERSION 0.4.0)
+set(PROJECT_VERSION 0.5.0)
 
 # 1. If the library source code has changed at all since the last update, then increment revision.
 # 2. If any interfaces have been added, removed, or changed since the last update, increment current, and set revision to 0.
 # 3. If any interfaces have been added since the last public release, then increment age.
 # 4. If any interfaces have been removed since the last public release, then set age to 0. 
 set(chromaprint_SOVERSION_CURRENT  1)
-set(chromaprint_SOVERSION_REVISION 2)
+set(chromaprint_SOVERSION_REVISION 3)
 set(chromaprint_SOVERSION_AGE      1)
 
 math(EXPR chromaprint_SOVERSION_MAJOR "${chromaprint_SOVERSION_CURRENT} - ${chromaprint_SOVERSION_AGE}")

=== debian/changelog ===
chromaprint (0.5-1) unstable; urgency=low

  * New upstream version.  closes: #651127.
  * Set maintainer to Debian QA Group.

 -- Clint Adams <clint@debian.org>  Sat, 10 Dec 2011 18:02:48 -0500

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,6 @@
 Source: chromaprint
 Priority: extra
-Maintainer: Clint Adams <clint@debian.org>
+Maintainer: Debian QA Group <packages@qa.debian.org>
 Build-Depends: debhelper (>= 7.0.50~), cmake, libavcodec-dev, libavformat-dev, libfftw3-dev, libgtest-dev, python-support, python-all-dev (>= 2.3.5-11)
 Standards-Version: 3.9.2
 Section: libs

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

CONFIGURE_FLAGS = -DCMAKE_BUILD_TYPE=Release

# FIXME the tests currently can't run with a out-of-source build
#ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
#CONFIGURE_FLAGS += -DBUILD_TESTS=ON
#endif

%:
	dh $@ 

override_dh_auto_configure:
	@dh_auto_configure -- $(CONFIGURE_FLAGS)
	@dh_auto_configure --sourcedirectory=python

override_dh_auto_build:
	@dh_auto_build
	@dh_auto_build --sourcedirectory=python

override_dh_auto_install:
	@dh_auto_install
	@dh_auto_install --sourcedirectory=python

override_dh_auto_clean:
	@dh_auto_clean
	@dh_auto_clean --sourcedirectory=python

=== debian/watch ===
version=3
https://github.com/lalinsky/chromaprint/downloads .*/chromaprint-([0-9].*)\.tar\.gz

## chromaprint 0.6

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,14 +1,14 @@
 cmake_minimum_required(VERSION 2.6)
 
 project(chromaprint)
-set(PROJECT_VERSION 0.5.0)
+set(PROJECT_VERSION 0.6.0)
 
 # 1. If the library source code has changed at all since the last update, then increment revision.
 # 2. If any interfaces have been added, removed, or changed since the last update, increment current, and set revision to 0.
 # 3. If any interfaces have been added since the last public release, then increment age.
 # 4. If any interfaces have been removed since the last public release, then set age to 0. 
 set(chromaprint_SOVERSION_CURRENT  1)
-set(chromaprint_SOVERSION_REVISION 3)
+set(chromaprint_SOVERSION_REVISION 4)
 set(chromaprint_SOVERSION_AGE      1)
 
 math(EXPR chromaprint_SOVERSION_MAJOR "${chromaprint_SOVERSION_CURRENT} - ${chromaprint_SOVERSION_AGE}")
@@ -151,6 +151,7 @@
 endif(BUILD_TOOLS OR BUILD_TOOLS_EXTRA)
 
 if(BUILD_TESTS)
+	find_package(Threads)
 	find_package(GTest REQUIRED)
 	add_subdirectory(tests)
 endif(BUILD_TESTS)

=== examples/CMakeLists.txt ===
set(EXTRA_LIBS)
if(APPLE)
    set(EXTRA_LIBS ${EXTRA_LIBS} -lz)
endif()
if(UNIX)
    set(EXTRA_LIBS ${EXTRA_LIBS} -lpthread)
endif()

set(CMAKE_REQUIRED_LIBRARIES
	${FFMPEG_LIBAVFORMAT_LIBRARIES}
	${FFMPEG_LIBAVCODEC_LIBRARIES}
	${FFMPEG_LIBAVUTIL_LIBRARIES}
	${EXTRA_LIBS})
check_function_exists(av_audio_convert HAVE_AV_AUDIO_CONVERT)

if(HAVE_AV_AUDIO_CONVERT)
	add_definitions(-DHAVE_AV_AUDIO_CONVERT)
endif()

include_directories(
	${CMAKE_CURRENT_SOURCE_DIR}/../src
	${FFMPEG_LIBAVCODEC_INCLUDE_DIRS}
	${FFMPEG_LIBAVFORMAT_INCLUDE_DIRS}
	${FFMPEG_LIBAVUTIL_INCLUDE_DIRS}
)

add_executable(fpcalc fpcalc.c)


target_link_libraries(fpcalc chromaprint
	${FFMPEG_LIBAVFORMAT_LIBRARIES}
	${FFMPEG_LIBAVCODEC_LIBRARIES}
	${FFMPEG_LIBAVUTIL_LIBRARIES}
	${EXTRA_LIBS})

install(TARGETS fpcalc
	RUNTIME DESTINATION ${BIN_INSTALL_DIR}
)

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -30,6 +30,7 @@
 add_executable(all_tests ${tests_SOURCES})
 target_link_libraries(all_tests
 	${GTEST_BOTH_LIBRARIES}
+	${CMAKE_THREAD_LIBS_INIT}
 	chromaprint_p
 )

=== debian/changelog ===
chromaprint (0.6-1) unstable; urgency=low

  * New upstream release
    - The Python bindings have been moved to the pyacoustid package,
      available in Debian as python-acoustid. The binary package
      python-chromaprint is therefore not built anymore.
  * Set Maintainer to Simon Chopin (Closes: #651823)
  * Change Vcs-* fields to point to the collab-maint Alioth repository.
  * Create new binary package libchromaprint-tools shipping the fpcalc binary
    (Closes: #649292)
  * Set Priority: optional because pyacoustid (rdep) is optional.
  * Add symbols file.
  * Fix package -dev description mixup
  * Enable multiarch support:
    - Add Multi-arch: same field for libchromaprint0.
    - Add the relevant Pre-depends field.
    - Pass the LIB_SUFFIX flag to cmake pointing to the multiarch directories.
  * Change debian/copyright format to DEP5.
  * Specify the copyright information for the ffmpeg headers in examples/.
  * Disable DH_VERBOSE debug output 
  * Add lintian override for the use of libchromaprint-private in
    libchromaprint0.symbols in order to prevent linking against the C++ STL
    symbols.

 -- Simon Chopin <chopin.simon@gmail.com>  Tue, 10 Jan 2012 15:34:55 +0100

=== debian/control ===
Source: chromaprint
Priority: optional
Maintainer: Simon Chopin <chopin.simon@gmail.com>
Build-Depends: cmake,
               debhelper (>= 8.1.3~),
               libavcodec-dev,
               libavformat-dev,
               libfftw3-dev,
               libgtest-dev,
               python-docutils (>= 0.6)
Standards-Version: 3.9.2
Section: libs
Homepage: http://wiki.acoustid.org/wiki/Chromaprint
Vcs-Git: git://git.debian.org/git/collab-maint/chromaprint.git
Vcs-Browser: http://git.debian.org/?p=collab-maint/chromaprint.git;a=summary

Package: libchromaprint-dev
Section: libdevel
Architecture: any
Depends: libchromaprint0 (= ${binary:Version}), ${misc:Depends}
Description: audio fingerprinting library - development files
 Chromaprint is a library for calculating audio fingerprints
 which are used by the Acoustid service. Its main purpose is to provide an
 accurate identifier for record tracks
 .
 This package includes development files needed to compile programs
 using libchromaprint.

Package: libchromaprint0
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: libchromaprint-bin, python-acoustid
Description: audio fingerprint library
 Chromaprint is a library for calculating audio fingerprints
 which are used by the Acoustid service. Its main purpose is to provide an
 accurate identifier for record tracks

Package: libchromaprint-tools
Section: sound
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: audio fingerprinting library - tools
 Chromaprint is a library for calculating audio fingerprints
 which are used by the Acoustid service. Its main purpose is to provide an
 accurate identifier for record tracks
 .
 This package provides the fpcalc utility.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

CONFIGURE_FLAGS = -DCMAKE_BUILD_TYPE=Release \
				  -DBUILD_EXAMPLES=True \
				  -DHAVE_AV_AUDIO_CONVERT=True \
				  -DLIB_SUFFIX="/$(DEB_HOST_MULTIARCH)" \

# FIXME the tests currently can't run with a out-of-source build
#ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
#CONFIGURE_FLAGS += -DBUILD_TESTS=ON
#endif

%:
	dh $@ 

override_dh_auto_configure:
	@dh_auto_configure -- $(CONFIGURE_FLAGS)

override_dh_installman:
	rst2man debian/fpcalc.rst > debian/fpcalc.1
	dh_installman

override_dh_clean:
	dh_clean
	rm -f debian/fpcalc.1

## chromaprint 0.7

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,15 +1,15 @@
 cmake_minimum_required(VERSION 2.6)
 
 project(chromaprint)
-set(PROJECT_VERSION 0.6.0)
+set(PROJECT_VERSION 0.7.0)
 
 # 1. If the library source code has changed at all since the last update, then increment revision.
 # 2. If any interfaces have been added, removed, or changed since the last update, increment current, and set revision to 0.
 # 3. If any interfaces have been added since the last public release, then increment age.
 # 4. If any interfaces have been removed since the last public release, then set age to 0. 
-set(chromaprint_SOVERSION_CURRENT  1)
-set(chromaprint_SOVERSION_REVISION 4)
-set(chromaprint_SOVERSION_AGE      1)
+set(chromaprint_SOVERSION_CURRENT  2)
+set(chromaprint_SOVERSION_REVISION 0)
+set(chromaprint_SOVERSION_AGE      2)
 
 math(EXPR chromaprint_SOVERSION_MAJOR "${chromaprint_SOVERSION_CURRENT} - ${chromaprint_SOVERSION_AGE}")
 math(EXPR chromaprint_SOVERSION_MINOR "${chromaprint_SOVERSION_AGE}")

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -25,6 +25,7 @@
 	test_filter.cpp
 	test_silence_remover.cpp
 	test_base64.cpp
+	test_moving_average.cpp
 )
 
 add_executable(all_tests ${tests_SOURCES})

=== debian/changelog ===
chromaprint (0.7-2) unstable; urgency=low

  * Upload to unstable

  [ Simon Chopin ]
  * Change the Vcs-* URLs to point to the pkg-multimedia repo
  * Update the watchfile to use bitbucket instead of github.
  * Use the branch master for Debian packaging in gbp.conf

  [ Sebastian Ramacher ]
  * debian/gbp.conf: Add pristine-tar = True.
  * debian/control:
    - Use canonical VCS-* URLs.
    - Bump Standards-Version (no changes required).

 -- Simon Chopin <chopin.simon@gmail.com>  Fri, 30 Aug 2013 19:50:17 +0200

chromaprint (0.7-1) experimental; urgency=low

  [ Simon Chopin ]
  * New upstream release
  * Add fix-libav9-ftbfs patch for libav9 compatibility. (Closes: #692912)
    Thanks to Reinhard Tartler.

  [ Reinhard Tartler ]
  * normalize fields with 'wrap-and-sort -as'
  * update Maintainers field, add myself to uploaders
  * make git-buildpackage work in branch 'exerimental'

 -- Reinhard Tartler <siretart@tauware.de>  Fri, 22 Feb 2013 07:08:44 +0100

chromaprint (0.6-2) unstable; urgency=low

  * debian/control: Fix Suggests: field from libchromaprint-bin to
    libchromaprint-tools (Closes: #668624)
  * Bump Standard-Version to 3.9.3
    + Change the Format: URL in debian/copyright.
  * Update copyright year.
  * debian/rules:
    + enable command echoing for the configuration step
  * Bump the version of debhelper in B-D to  >= 9 since the package is using
    compat 9 and remove the lintian override accordingly.
  * debian/copyright: Fix typo in the copyright years for the upstream part
    (thanks to Bart Martens).

 -- Simon Chopin <chopin.simon@gmail.com>  Sat, 19 May 2012 16:08:47 +0200

=== debian/control ===
Source: chromaprint
Priority: optional
Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
Uploaders: Simon Chopin <chopin.simon@gmail.com>, Reinhard Tartler <siretart@tauware.de>
Build-Depends:
 cmake,
 debhelper (>= 9),
 libavcodec-dev,
 libavformat-dev,
 libfftw3-dev,
 libgtest-dev,
 python-docutils (>= 0.6)
Standards-Version: 3.9.4
Section: libs
Homepage: http://wiki.acoustid.org/wiki/Chromaprint
Vcs-Git: git://anonscm.debian.org/pkg-multimedia/chromaprint.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-multimedia/chromaprint.git;a=summary

Package: libchromaprint-dev
Section: libdevel
Architecture: any
Depends:
 libchromaprint0 (= ${binary:Version}),
 ${misc:Depends}
Description: audio fingerprinting library - development files
 Chromaprint is a library for calculating audio fingerprints
 which are used by the Acoustid service. Its main purpose is to provide an
 accurate identifier for record tracks
 .
 This package includes development files needed to compile programs
 using libchromaprint.

Package: libchromaprint0
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Suggests:
 libchromaprint-tools,
 python-acoustid
Description: audio fingerprint library
 Chromaprint is a library for calculating audio fingerprints
 which are used by the Acoustid service. Its main purpose is to provide an
 accurate identifier for record tracks

Package: libchromaprint-tools
Section: sound
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: audio fingerprinting library - tools
 Chromaprint is a library for calculating audio fingerprints
 which are used by the Acoustid service. Its main purpose is to provide an
 accurate identifier for record tracks
 .
 This package provides the fpcalc utility.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# export DH_VERBOSE=1

CONFIGURE_FLAGS = -DCMAKE_BUILD_TYPE=Release \
				  -DBUILD_EXAMPLES=True \
				  -DHAVE_AV_AUDIO_CONVERT=True \
				  -DLIB_SUFFIX="/$(DEB_HOST_MULTIARCH)" \

# FIXME the tests currently can't run with a out-of-source build
# TODO: patch the build system to build libgtest and fix the out-of-source
# problem.
#ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
#CONFIGURE_FLAGS += -DBUILD_TESTS=ON
#endif

%:
	dh $@ 

override_dh_auto_configure:
	dh_auto_configure -- $(CONFIGURE_FLAGS)

override_dh_installman:
	rst2man debian/fpcalc.rst > debian/fpcalc.1
	dh_installman

override_dh_clean:
	dh_clean
	rm -f debian/fpcalc.1

## chromaprint 1.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,14 +1,14 @@
 cmake_minimum_required(VERSION 2.6)
 
 project(chromaprint)
-set(PROJECT_VERSION 0.7.0)
+set(PROJECT_VERSION 1.1.0)
 
 # 1. If the library source code has changed at all since the last update, then increment revision.
 # 2. If any interfaces have been added, removed, or changed since the last update, increment current, and set revision to 0.
 # 3. If any interfaces have been added since the last public release, then increment age.
 # 4. If any interfaces have been removed since the last public release, then set age to 0. 
 set(chromaprint_SOVERSION_CURRENT  2)
-set(chromaprint_SOVERSION_REVISION 0)
+set(chromaprint_SOVERSION_REVISION 2)
 set(chromaprint_SOVERSION_AGE      2)
 
 math(EXPR chromaprint_SOVERSION_MAJOR "${chromaprint_SOVERSION_CURRENT} - ${chromaprint_SOVERSION_AGE}")
@@ -53,10 +53,6 @@
 if(CMAKE_COMPILER_IS_GNUCXX)
 	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall")
 	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall")
-endif()
-if(CMAKE_COMPILER_IS_GNUCXX AND BUILD_SHARED_LIBS)
-	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility=hidden -fvisibility-inlines-hidden")
-	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fvisibility=hidden")
 endif()
 
 if(NOT BUILD_SHARED_LIBS)

=== examples/CMakeLists.txt ===
--- 
+++ 
@@ -11,11 +11,6 @@
 	${FFMPEG_LIBAVCODEC_LIBRARIES}
 	${FFMPEG_LIBAVUTIL_LIBRARIES}
 	${EXTRA_LIBS})
-check_function_exists(av_audio_convert HAVE_AV_AUDIO_CONVERT)
-
-if(HAVE_AV_AUDIO_CONVERT)
-	add_definitions(-DHAVE_AV_AUDIO_CONVERT)
-endif()
 
 include_directories(
 	${CMAKE_CURRENT_SOURCE_DIR}/../src
@@ -26,13 +21,24 @@
 
 add_executable(fpcalc fpcalc.c)
 
-
 target_link_libraries(fpcalc chromaprint
 	${FFMPEG_LIBAVFORMAT_LIBRARIES}
 	${FFMPEG_LIBAVCODEC_LIBRARIES}
 	${FFMPEG_LIBAVUTIL_LIBRARIES}
 	${EXTRA_LIBS})
 
+if(FFMPEG_LIBSWRESAMPLE_FOUND)
+	add_definitions(-DHAVE_SWRESAMPLE)
+	include_directories(${FFMPEG_LIBSWRESAMPLE_INCLUDE_DIRS})
+	target_link_libraries(fpcalc ${FFMPEG_LIBSWRESAMPLE_LIBRARIES})
+elseif(FFMPEG_LIBAVRESAMPLE_FOUND)
+	add_definitions(-DHAVE_AVRESAMPLE)
+	include_directories(${FFMPEG_LIBAVRESAMPLE_INCLUDE_DIRS})
+	target_link_libraries(fpcalc ${FFMPEG_LIBAVRESAMPLE_LIBRARIES})
+else()
+	message(STATUS "Building without audio conversion support, please install FFmpeg with libswresample")
+endif()
+
 install(TARGETS fpcalc
 	RUNTIME DESTINATION ${BIN_INSTALL_DIR}
 )

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,9 @@
 include_directories(${CMAKE_CURRENT_SOURCE_DIR})
+
+if(CMAKE_COMPILER_IS_GNUCXX AND BUILD_SHARED_LIBS)
+	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility=hidden -fvisibility-inlines-hidden")
+	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fvisibility=hidden")
+endif()
 
 set(chromaprint_SRCS
 	chromaprint.cpp
@@ -48,6 +53,8 @@
 endif()
 
 add_library(chromaprint_p STATIC ${chromaprint_SRCS})
+set_target_properties(chromaprint_p PROPERTIES
+	COMPILE_DEFINITIONS CHROMAPRINT_NODLL)
 target_link_libraries(chromaprint_p ${chromaprint_LINK_LIBS})
 
 set(chromaprint_HDRS chromaprint.h)

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,9 @@
 include_directories(
 	${GTEST_INCLUDE_DIRS}
+	${Boost_INCLUDE_DIRS}
 	${CMAKE_CURRENT_SOURCE_DIR}/../src
 )
+add_subdirectory(${GTEST_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR}/gtest_build)
 
 set(tests_SOURCES
 	main.cpp
@@ -29,6 +31,8 @@
 )
 
 add_executable(all_tests ${tests_SOURCES})
+set_target_properties(all_tests PROPERTIES
+	COMPILE_DEFINITIONS CHROMAPRINT_NODLL)
 target_link_libraries(all_tests
 	${GTEST_BOTH_LIBRARIES}
 	${CMAKE_THREAD_LIBS_INIT}
@@ -36,7 +40,9 @@
 )
 
 add_custom_target(check
-	./all_tests $ENV{GTEST_FLAGS}
-	DEPENDS all_tests
-)
+	${CMAKE_CURRENT_BINARY_DIR}/all_tests
+	$ENV{GTEST_FLAGS} DEPENDS all_tests)
 
+enable_testing(true)
+add_test(ChromaprintTests all_tests)
+

=== tools/CMakeLists.txt ===
--- 
+++ 
@@ -53,12 +53,6 @@
 
 endif(BUILD_EXTRA_TOOLS)
 
-add_executable(fpgen fpgen.cpp)
-target_link_libraries(fpgen chromaprint_p
-	${FFMPEG_LIBAVFORMAT_LIBRARIES}
-	${FFMPEG_LIBAVCODEC_LIBRARIES}
-	${FFMPEG_LIBAVUTIL_LIBRARIES})
-
 if(NOT MSVC)
 add_executable(fpcollect fpcollect.cpp)
 target_link_libraries(fpcollect chromaprint_p

=== debian/changelog ===
chromaprint (1.1-1) unstable; urgency=low

  * New upstream release

 -- Simon Chopin <chopin.simon@gmail.com>  Mon, 02 Dec 2013 00:50:08 +0100

=== debian/control ===
--- 
+++ 
@@ -7,10 +7,11 @@
  debhelper (>= 9),
  libavcodec-dev,
  libavformat-dev,
+ libavresample-dev,
  libfftw3-dev,
  libgtest-dev,
  python-docutils (>= 0.6)
-Standards-Version: 3.9.4
+Standards-Version: 3.9.5
 Section: libs
 Homepage: http://wiki.acoustid.org/wiki/Chromaprint
 Vcs-Git: git://anonscm.debian.org/pkg-multimedia/chromaprint.git

=== debian/watch ===
version=3
https://bitbucket.org/acoustid/chromaprint/downloads/chromaprint-([0-9].*)\.tar\.gz

## chromaprint 1.2

=== debian/changelog ===
chromaprint (1.2-1build1) wily; urgency=medium

  * No-change rebuild against ffmpeg 2.7

 -- Rico Tzschichholz <ricotz@ubuntu.com>  Tue, 01 Sep 2015 18:00:11 +0200

chromaprint (1.2-1) unstable; urgency=medium

  * New upstream release

 -- Simon Chopin <chopin.simon@gmail.com>  Sun, 28 Sep 2014 20:27:39 +0200

## chromaprint 1.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,14 +1,14 @@
 cmake_minimum_required(VERSION 2.6)
 
 project(chromaprint)
-set(PROJECT_VERSION 1.1.0)
+set(PROJECT_VERSION 1.2.0)
 
 # 1. If the library source code has changed at all since the last update, then increment revision.
 # 2. If any interfaces have been added, removed, or changed since the last update, increment current, and set revision to 0.
 # 3. If any interfaces have been added since the last public release, then increment age.
 # 4. If any interfaces have been removed since the last public release, then set age to 0. 
 set(chromaprint_SOVERSION_CURRENT  2)
-set(chromaprint_SOVERSION_REVISION 2)
+set(chromaprint_SOVERSION_REVISION 3)
 set(chromaprint_SOVERSION_AGE      2)
 
 math(EXPR chromaprint_SOVERSION_MAJOR "${chromaprint_SOVERSION_CURRENT} - ${chromaprint_SOVERSION_AGE}")
@@ -47,8 +47,6 @@
 option(BUILD_SHARED_LIBS "Build shared libraries" ON)
 option(BUILD_EXAMPLES "Build the examples" OFF)
 option(BUILD_TESTS "Build the test suite" OFF)
-option(BUILD_TOOLS "Build standard tools" OFF)
-option(BUILD_EXTRA_TOOLS "Build extra tools (only useful for development of this library)" OFF)
 
 if(CMAKE_COMPILER_IS_GNUCXX)
 	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall")
@@ -62,6 +60,7 @@
 option(WITH_AVFFT "Use FFmpeg for FFT calculations" OFF)
 option(WITH_FFTW3 "Use FFTW3 for FFT calculations" OFF)
 option(WITH_VDSP "Use vDSP for FFT calculations" OFF)
+option(WITH_KISSFFT "Use KissFFT for FFT calculations" OFF)
 
 set(TESTS_DIR ${CMAKE_CURRENT_SOURCE_DIR}/tests/)
 
@@ -71,6 +70,7 @@
 if(APPLE)
 	find_library(ACCELERATE_LIBRARIES Accelerate)
 endif()
+find_package(KissFFT)
 
 set(FFT_OPTION_COUNT 0)
 
@@ -83,8 +83,11 @@
 if(WITH_VDSP)
 	math(EXPR FFT_OPTION_COUNT "${FFT_OPTION_COUNT} + 1")
 endif()
+if(WITH_KISSFFT)
+	math(EXPR FFT_OPTION_COUNT "${FFT_OPTION_COUNT} + 1")
+endif()
 if(FFT_OPTION_COUNT GREATER "1")
-	message(FATAL_ERROR "Only one of WITH_AVFFT, WITH_FFTW3 AND WITH_VDSP can be selected")
+	message(FATAL_ERROR "Only one of WITH_AVFFT, WITH_FFTW3, WITH_VDSP and WITH_KISSFFT can be selected")
 endif()
 
 if(WITH_AVFFT AND NOT FFMPEG_LIBAVCODEC_FFT_FOUND)
@@ -99,13 +102,19 @@
 	message(FATAL_ERROR "vDSP (Accelerate) not found")
 endif()
 
-if(NOT WITH_AVFFT AND NOT WITH_FFTW3)
+if(WITH_KISSFFT AND NOT KISSFFT_FOUND)
+	message(FATAL_ERROR "KissFFT not found")
+endif()
+
+if(NOT WITH_AVFFT AND NOT WITH_FFTW3 AND NOT WITH_KISSFFT)
 	if(APPLE AND ACCELERATE_LIBRARIES)
 		set(WITH_VDSP ON)
 	elseif(FFMPEG_LIBAVCODEC_FFT_FOUND)
 		set(WITH_AVFFT ON)
 	elseif(FFTW3_FOUND)
 		set(WITH_FFTW3 ON)
+	elseif(KISSFFT_FOUND)
+		set(WITH_KISSFFT ON)
 	else()
 		message(FATAL_ERROR "Neither FFmpeg with avfft.h nor FFTW3 found")
 	endif()
@@ -113,13 +122,17 @@
 
 if(WITH_AVFFT)
 	message(STATUS "Using FFmpeg for FFT calculations")
-endif(WITH_AVFFT)
+endif()
 
 if(WITH_FFTW3)
 	message(STATUS "Using FFTW3 for FFT calculations")
-endif(WITH_FFTW3)
+endif()
 
-if(NOT APPLE AND NOT BUILD_FRAMEWORK)
+if(WITH_KISSFFT)
+	message(STATUS "Using KissFFT for FFT calculations")
+endif()
+
+if(NOT BUILD_FRAMEWORK)
 	configure_file(${CMAKE_CURRENT_SOURCE_DIR}/libchromaprint.pc.cmake ${CMAKE_CURRENT_BINARY_DIR}/libchromaprint.pc)
 	install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libchromaprint.pc DESTINATION ${LIB_INSTALL_DIR}/pkgconfig)
 endif()
@@ -128,12 +141,8 @@
 
 add_subdirectory(src)
 
-if(BUILD_TOOLS_EXTRA)
-	find_package(PNG REQUIRED)
-endif(BUILD_TOOLS_EXTRA)
-
 find_package(Boost COMPONENTS system filesystem)
-if(BUILD_TOOLS OR BUILD_TOOLS_EXTRA OR BUILD_EXAMPLES)
+if(BUILD_EXAMPLES)
 	find_package(FFmpeg REQUIRED)
 endif()
 
@@ -141,14 +150,17 @@
 	add_subdirectory(examples)
 endif()
 
-if(BUILD_TOOLS OR BUILD_TOOLS_EXTRA)
-	find_package(Taglib REQUIRED)
-	add_subdirectory(tools)
-endif(BUILD_TOOLS OR BUILD_TOOLS_EXTRA)
-
 if(BUILD_TESTS)
 	find_package(Threads)
 	find_package(GTest REQUIRED)
 	add_subdirectory(tests)
 endif(BUILD_TESTS)
 
+configure_file(
+	"${CMAKE_CURRENT_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in"
+	"${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
+	IMMEDIATE @ONLY)
+
+add_custom_target(uninstall
+	COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)
+

=== examples/CMakeLists.txt ===
set(EXTRA_LIBS)
if(APPLE)
    set(EXTRA_LIBS ${EXTRA_LIBS} -lz)
    set(CMAKE_EXE_LINKER_FLAGS "-sectcreate __TEXT __info_plist ${CMAKE_CURRENT_SOURCE_DIR}/Info.plist")
endif()
if(UNIX)
    set(EXTRA_LIBS ${EXTRA_LIBS} -lpthread -lm)
endif()

set(CMAKE_REQUIRED_LIBRARIES
	${FFMPEG_LIBAVFORMAT_LIBRARIES}
	${FFMPEG_LIBAVCODEC_LIBRARIES}
	${FFMPEG_LIBAVUTIL_LIBRARIES}
	${EXTRA_LIBS})

include_directories(
	${CMAKE_CURRENT_SOURCE_DIR}/../src
	${FFMPEG_LIBAVCODEC_INCLUDE_DIRS}
	${FFMPEG_LIBAVFORMAT_INCLUDE_DIRS}
	${FFMPEG_LIBAVUTIL_INCLUDE_DIRS}
)

set(fpcalc_LIBS
	chromaprint
	${FFMPEG_LIBAVFORMAT_LIBRARIES}
	${FFMPEG_LIBAVCODEC_LIBRARIES})

if(FFMPEG_LIBSWRESAMPLE_FOUND)
	add_definitions(-DHAVE_SWRESAMPLE)
	include_directories(${FFMPEG_LIBSWRESAMPLE_INCLUDE_DIRS})
	set(fpcalc_LIBS ${fpcalc_LIBS} ${FFMPEG_LIBSWRESAMPLE_LIBRARIES})
elseif(FFMPEG_LIBAVRESAMPLE_FOUND)
	add_definitions(-DHAVE_AVRESAMPLE)
	include_directories(${FFMPEG_LIBAVRESAMPLE_INCLUDE_DIRS})
	set(fpcalc_LIBS ${fpcalc_LIBS} ${FFMPEG_LIBAVRESAMPLE_LIBRARIES})
else()
	message(STATUS "Building without audio conversion support, please install FFmpeg with libswresample")
endif()

set(fpcalc_LIBS ${fpcalc_LIBS}
	${FFMPEG_LIBAVUTIL_LIBRARIES}
	${EXTRA_LIBS})

add_executable(fpcalc fpcalc.c)

target_link_libraries(fpcalc ${fpcalc_LIBS})

install(TARGETS fpcalc
	RUNTIME DESTINATION ${BIN_INSTALL_DIR}
)

=== debian/changelog ===
chromaprint (1.3-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * debian/patches: Removed, included upstream.
  * debian/control: Bump Standards-Version.
  * debian/libchromaprint0.symbols: Add new symbols.

 -- Sebastian Ramacher <sramacher@debian.org>  Sun, 07 Feb 2016 21:58:50 +0100

chromaprint (1.2-2) unstable; urgency=medium

  * Team upload.
  * debian/control:
    - Update Homepage.
    - Update and Vcs-*.
    - Bump Standards Version.
  * debian/patches/remove-deprecated-lavc-APIs.patch: Apply upstream patch to
    fix FTBFS with ffmpeg 2.9/3.0 (Closes: #803805)

 -- Sebastian Ramacher <sramacher@debian.org>  Fri, 29 Jan 2016 21:46:05 +0100

=== debian/control ===
--- 
+++ 
@@ -11,11 +11,11 @@
  libfftw3-dev,
  libgtest-dev,
  python-docutils (>= 0.6)
-Standards-Version: 3.9.5
+Standards-Version: 3.9.7
 Section: libs
-Homepage: http://wiki.acoustid.org/wiki/Chromaprint
-Vcs-Git: git://anonscm.debian.org/pkg-multimedia/chromaprint.git
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-multimedia/chromaprint.git;a=summary
+Homepage: https://acoustid.org/chromaprint
+Vcs-Git: https://anonscm.debian.org/git/pkg-multimedia/chromaprint.git
+Vcs-Browser: https://anonscm.debian.org/cgit/pkg-multimedia/chromaprint.git
 
 Package: libchromaprint-dev
 Section: libdevel

=== debian/rules ===
--- 
+++ 
@@ -4,7 +4,6 @@
 
 CONFIGURE_FLAGS = -DCMAKE_BUILD_TYPE=Release \
 				  -DBUILD_EXAMPLES=True \
-				  -DHAVE_AV_AUDIO_CONVERT=True \
 				  -DLIB_SUFFIX="/$(DEB_HOST_MULTIARCH)" \
 
 # FIXME the tests currently can't run with a out-of-source build
@@ -27,3 +26,6 @@
 override_dh_clean:
 	dh_clean
 	rm -f debian/fpcalc.1
+
+override_dh_installchangelogs:
+	dh_installchangelogs NEWS.txt

## chromaprint 1.3.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,15 +1,19 @@
 cmake_minimum_required(VERSION 2.6)
 
+if(POLICY CMP0048)
+    cmake_policy(SET CMP0048 OLD)
+endif()
+
 project(chromaprint)
-set(PROJECT_VERSION 1.2.0)
+set(PROJECT_VERSION 1.3.1)
 
 # 1. If the library source code has changed at all since the last update, then increment revision.
 # 2. If any interfaces have been added, removed, or changed since the last update, increment current, and set revision to 0.
 # 3. If any interfaces have been added since the last public release, then increment age.
 # 4. If any interfaces have been removed since the last public release, then set age to 0. 
-set(chromaprint_SOVERSION_CURRENT  2)
-set(chromaprint_SOVERSION_REVISION 3)
-set(chromaprint_SOVERSION_AGE      2)
+set(chromaprint_SOVERSION_CURRENT  4)
+set(chromaprint_SOVERSION_REVISION 0)
+set(chromaprint_SOVERSION_AGE      3)
 
 math(EXPR chromaprint_SOVERSION_MAJOR "${chromaprint_SOVERSION_CURRENT} - ${chromaprint_SOVERSION_AGE}")
 math(EXPR chromaprint_SOVERSION_MINOR "${chromaprint_SOVERSION_AGE}")

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -19,6 +19,8 @@
 	fingerprinter.cpp
 	image_builder.cpp
 	lloyds.cpp
+	simhash.h
+	simhash.cpp
 	silence_remover.cpp
 	fingerprint_calculator.cpp
 	fingerprint_compressor.cpp
@@ -52,6 +54,11 @@
 	set(chromaprint_LINK_LIBS ${ACCELERATE_LIBRARIES})
 endif()
 
+if(WITH_KISSFFT)
+	set(chromaprint_SRCS fft_lib_kissfft.cpp ${chromaprint_SRCS} ${KISSFFT_SOURCES})
+	include_directories(${KISSFFT_INCLUDE_DIRS})
+endif()
+
 add_library(chromaprint_p STATIC ${chromaprint_SRCS})
 set_target_properties(chromaprint_p PROPERTIES
 	COMPILE_DEFINITIONS CHROMAPRINT_NODLL)

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -17,6 +17,7 @@
 	test_audio_processor.cpp
 	test_bit_string_reader.cpp
 	test_bit_string_writer.cpp
+	test_simhash.cpp
 	test_chromaprint.cpp
 	test_chroma.cpp
 	test_chroma_filter.cpp

=== debian/changelog ===
chromaprint (1.3.2-2) unstable; urgency=medium

  * Team upload.
  * Upload to unstable.

 -- Sebastian Ramacher <sramacher@debian.org>  Fri, 02 Sep 2016 10:01:00 +0200

chromaprint (1.3.2-1) experimental; urgency=medium

  * Team upload.
  * New upstream release.
  * SONAME bump: libchromaprint0 -> libchromaprint1
  * debian/rules: Enable parallel build.
  * debian/control: Bump Standards-Version.

 -- Sebastian Ramacher <sramacher@debian.org>  Sun, 28 Aug 2016 13:42:25 +0200

=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
  libfftw3-dev,
  libgtest-dev,
  python-docutils (>= 0.6)
-Standards-Version: 3.9.7
+Standards-Version: 3.9.8
 Section: libs
 Homepage: https://acoustid.org/chromaprint
 Vcs-Git: https://anonscm.debian.org/git/pkg-multimedia/chromaprint.git
@@ -21,7 +21,7 @@
 Section: libdevel
 Architecture: any
 Depends:
- libchromaprint0 (= ${binary:Version}),
+ libchromaprint1 (= ${binary:Version}),
  ${misc:Depends}
 Description: audio fingerprinting library - development files
  Chromaprint is a library for calculating audio fingerprints
@@ -31,16 +31,13 @@
  This package includes development files needed to compile programs
  using libchromaprint.
 
-Package: libchromaprint0
+Package: libchromaprint1
 Architecture: any
 Multi-Arch: same
 Pre-Depends: ${misc:Pre-Depends}
 Depends:
  ${misc:Depends},
  ${shlibs:Depends}
-Suggests:
- libchromaprint-tools,
- python-acoustid
 Description: audio fingerprint library
  Chromaprint is a library for calculating audio fingerprints
  which are used by the Acoustid service. Its main purpose is to provide an

=== debian/rules ===
--- 
+++ 
@@ -14,7 +14,7 @@
 #endif
 
 %:
-	dh $@ 
+	dh $@ --parallel
 
 override_dh_auto_configure:
 	dh_auto_configure -- $(CONFIGURE_FLAGS)
@@ -23,9 +23,5 @@
 	rst2man debian/fpcalc.rst > debian/fpcalc.1
 	dh_installman
 
-override_dh_clean:
-	dh_clean
-	rm -f debian/fpcalc.1
-
 override_dh_installchangelogs:
 	dh_installchangelogs NEWS.txt
